﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.SqlClient;
using SqlDataReaderADONET.DirectSql;
using System;
using System.Collections.Generic;
using System.Data;

namespace SqlDataReaderADONET.Controllers
{
    [Route("parameters")]
    public class ParametersController : Controller
    {

        public IActionResult Index()
        {
            // Количество повторений
            int numRepeat = 100;
            ViewBag.NumRepeat = numRepeat;


            // --- Запросы без параметров ---
            DataTable dataTableNoParameters = null;
            DateTime dtNoParameters = DateTime.Now;
            for (int i = 0; i < numRepeat; i++)
            {
                dataTableNoParameters = SqlQueries.CreateQuerySqlOneTable("SELECT * FROM Test WHERE Id='1'");
            }
            ViewBag.PerformanceNoParameters = (DateTime.Now - dtNoParameters).TotalMilliseconds;
            ViewBag.DataTableNoParameters = dataTableNoParameters;



            // --- Запросы с параметрами ---

            List<SqlParameter> parameters = new();

            SqlParameter Id = new()
            {
                DbType = DbType.Int32,
                Direction = ParameterDirection.Output,
                ParameterName = "Id",
                SourceColumn = "Id",
                Size = -1
            };
            parameters.Add(Id);

            SqlParameter T1 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T1",
                Size = -1
            };
            parameters.Add(T1);

            SqlParameter T2 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T2",
                Size = -1
            };
            parameters.Add(T2);


            SqlParameter T3 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T3",
                Size = -1
            };
            parameters.Add(T3);

            SqlParameter T4 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T4",
                Size = -1
            };
            parameters.Add(T4);

            SqlParameter T5 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T5",
                Size = -1
            };
            parameters.Add(T5);

            SqlParameter T6 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T6",
                Size = -1
            };
            parameters.Add(T6);

            SqlParameter T7 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T7",
                Size = -1
            };
            parameters.Add(T7);

            SqlParameter T8 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T8",
                Size = -1
            };
            parameters.Add(T8);

            SqlParameter T9 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T9",
                Size = -1
            };
            parameters.Add(T9);

            SqlParameter T10 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T10",
                Size = -1
            };
            parameters.Add(T10);

            SqlParameter T11 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T11",
                Size = -1
            };
            parameters.Add(T11);

            SqlParameter T12 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T12",
                Size = -1
            };
            parameters.Add(T12);

            SqlParameter T13 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T13",
                Size = -1
            };
            parameters.Add(T13);

            SqlParameter T14 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T14",
                Size = -1
            };
            parameters.Add(T14);

            SqlParameter T15 = new()
            {
                DbType = DbType.String,
                Direction = ParameterDirection.Output,
                ParameterName = "T15",
                Size = -1
            };
            parameters.Add(T15);


            DateTime dtParameters = DateTime.Now;
            for (int i = 0; i < numRepeat; i++)
            {
                // Возврат не требуется.
                SqlQueries.CreateQuerySqlSeveralTables(@"SELECT @Id=Id,
                @T1=T1, @T2=T2, @T3=T3, @T4=T4, @T5=T5, @T6=T6, @T7=T7, @T8=T8, @T9=T9, @T10=T10, @T11=T11, @T12=T12, @T13=T13, @T14=T14, @T15=T15
                FROM Test WHERE Id='1'", parameters);
            }
            ViewBag.PerformanceParameters = (DateTime.Now - dtParameters).TotalMilliseconds;
            ViewBag.Parameters = parameters;

            return View();
        }

    }
}
