﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Data.SqlClient;
using SqlDataReaderADONET.DirectSql;
using SqlDataReaderADONET.PashaCode;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;

namespace SqlDataReaderADONET.Controllers
{

    public class SqlDataTableController : Controller
    {
        [HttpPost]
        [HttpGet]
        public IActionResult Index(string name, string description, IFormFile image)
        {

            if (HttpContext.Request.Method == "POST")
            {
                string qs = "UPDATE TableData SET Name='" + name +
                            "', Description='" + description + "' WHERE Id='1'"; // работает

                List<SqlParameter> sqlParameters = new();

                if (image != null)
                {
                    Stream streamImage = image.OpenReadStream();
                    byte[] bytesImage = new byte[image.Length];
                    streamImage.Read(bytesImage, 0, (int)image.Length);

                    /* // SQL-способ обновления данных. 
                    string hexData = "0x" + Convert.ToHexString(bytesImage); // работает

                    // Обновление SQL инструкцией.
                    qs = "UPDATE TableData SET Name='" + name +
                    "', Description='" + description +
                    "', ImageName='" + image.FileName +
                    "', ImageData=CONVERT(VARBINARY(MAX), " + hexData + ") WHERE Id='1'"; // работает
                    */

                    // Обновление посредством параметра для бинарных данных.
                    SqlParameter binary = new()
                    {
                        SqlDbType = SqlDbType.VarBinary,
                        Direction = ParameterDirection.Input,
                        ParameterName = "ImgData",
                        Value = bytesImage
                    };
                    sqlParameters.Add(binary);

                    qs = "UPDATE TableData SET Name='" + name +
                    "', Description='" + description +
                    "', ImageName='" + image.FileName +
                    "', ImageData=@ImgData WHERE Id='1'"; // работает

                }


                SqlQueries.CreateQuerySqlOneTable(qs, sqlParameters);
            }



            // Строка запроса
            string queryString = "SELECT * FROM  TableData WHERE Id='1'";

            // Запросы для нескольких таблиц
            DataTable dataTable = SqlQueries.CreateQuerySqlOneTable(queryString);


            return View(dataTable);
        }



        [Route("/images/{filename}")]
        public IActionResult Images(string filename)
        {

            // Строка запроса
            string queryString = "SELECT ImageData FROM  TableData WHERE ImageName='" + filename + "'";

            // Запросы для нескольких таблиц
            List<DataTable> dataTables = SqlQueries.CreateQuerySqlSeveralTables(queryString);

            FileInfo fi = new(filename);
            var contentType = MyUtility.ContentTypes(fi.Extension);


            return File(dataTables[0].Rows[0].Field<byte[]>("ImageData"), contentType);
        }



    }
}
